class CachedSkillpoints {
    MapInstance@[] list;

    void Load() {
        string path = IO::FromStorageFolder("CachedSkillpoints.json");

        auto json = Json::FromFile(path);
        if (json.GetType() == Json::Type::Null) {
        	return;
        }

        if (json.GetType() != Json::Type::Object) {
            return;
        }

        auto maps = json.Get("maps", Json::Array());
        for (uint i = 0; i < maps.Length; i++) {
            list.InsertLast(MapInstance(maps[i].Get("uid", Json::Type::String), maps[i].Get("value", Json::Type::Number)));
        }
    }

    int GetPoints(string _uid) {
        for (uint i = 0; i < list.Length; i++) {
            if (list[i].uid == _uid) {
                return list[i].value;
            }
        }
        return -1;
    }

    int GetTotalPoints() {
        int total = 0;

        for (uint i = 0; i < list.Length; i++) {
            total += list[i].value;
        }
        return total;
    }


    void Save() {
        string path = IO::FromStorageFolder("CachedSkillpoints.json");
        auto json = Json::Object();
        auto maps = Json::Array();

        for (uint i = 0; i < list.Length; i++) {
            auto map = Json::Object();
            map["uid"] = list[i].uid;
            map["value"] = list[i].value;
            maps.Add(map);
        }

        json["maps"] = maps;
        Json::ToFile(path, json);
    }

    void Add(string _uid, int _value) {
        list.InsertLast(MapInstance(_uid, _value));
        // Save();
    }

    bool Exists(string _uid) {
        for (uint i = 0; i < list.Length; i++) {
            if (list[i].uid == _uid) {
                return true;
            }
        }
        return false;
    }


    void UpdateValue(string _uid, int _value) {
        for (uint i = 0; i < list.Length; i++) {
            if (list[i].uid == _uid) {
                list[i].value = _value;
            }
        }
        // Save();
    }
}

class MapInstance {
    MapInstance(const string&in _uid, const int&in _value) {
        uid = _uid;
        value = _value;
    }

    bool opEquals(const MapInstance&in inst) {
        if (this.value == inst.value) return true;
        return false;
    }

    int opCmp(const MapInstance&in inst) {
        if (this.value > inst.value) return 1;
        if (this.value < inst.value) return -1;
        return 0;
    }

    string uid;
    int value;
}